// DShowInputDriver: DirectShow based input plugin for VirtualDub
// Copyright (C) 2010-2011 Avery Lee
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

#ifndef UTILS_H
#define UTILS_H

struct IFilterGraph;
class VDStringA;

class MediaTypePtr {
public:
	MediaTypePtr();
	MediaTypePtr(const AM_MEDIA_TYPE *);
	MediaTypePtr(const MediaTypePtr& src);
	~MediaTypePtr();

	MediaTypePtr& operator=(const AM_MEDIA_TYPE *);
	MediaTypePtr& operator=(const MediaTypePtr& p);

	operator AM_MEDIA_TYPE *() { return mpMediaType; }
	operator const AM_MEDIA_TYPE *() const { return mpMediaType; }

	AM_MEDIA_TYPE *operator->() { return mpMediaType; }
	const AM_MEDIA_TYPE *operator->() const { return mpMediaType; }

	void Attach(AM_MEDIA_TYPE *);
	AM_MEDIA_TYPE *Detach();

protected:
	AM_MEDIA_TYPE	*mpMediaType;
};

class Lock {
public:
	Lock();
	Lock(const Lock&);
	~Lock();

	Lock& operator=(const Lock&) { return *this; }

	void Enter();
	void Exit();

protected:
	CRITICAL_SECTION	mCsect;
};

bool DSAreMediaTypesEqual(const AM_MEDIA_TYPE *p, const AM_MEDIA_TYPE *q);
bool DSAddToRot(IUnknown *pUnkGraph, DWORD *pdwRegister);
void DSRemoveFromRot(DWORD pdwRegister);
void DSListFilters(IFilterGraph *pGraph, VDStringA& s);

#endif
