// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently, but
// are changed infrequently
//

#pragma once

#define _CRT_SECURE_NO_WARNINGS
#define NO_DSHOW_STRSAFE

#ifndef _WIN32_WINNT		// Allow use of features specific to Windows XP or later.                   
#define _WIN32_WINNT 0x0501	// Change this to the appropriate value to target other versions of Windows.
#endif						

#include <stdio.h>
#include <tchar.h>

#include <windows.h>
#include <dshow.h>
#include <dvdmedia.h>
#include <comip.h>

#include <vector>


///////////////////////////////////////////////////////////////////////////
// qedit.h replacement
//
// Microsoft dropped <qedit.h> when DirectShow was moved from the DirectX
// SDK to the Platform/Windows SDK, and they never put it back. Doing a
// straight #import throws a buttload of duplicate definition errors, so
// we copy the specifically needed interfaces here.
//
// #import "libid:78530B68-61F9-11D2-8CAD-00A024580902" raw_interfaces_only no_namespace named_guids

extern "C" const GUID __declspec(selectany) CLSID_SampleGrabber =
    {0xc1f400a0,0x3f08,0x11d3,{0x9f,0x0b,0x00,0x60,0x08,0x03,0x9e,0x37}};
extern "C" const GUID __declspec(selectany) CLSID_NullRenderer =
    {0xc1f400a4,0x3f08,0x11d3,{0x9f,0x0b,0x00,0x60,0x08,0x03,0x9e,0x37}};
extern "C" const GUID __declspec(selectany) CLSID_MediaDet =
    {0x65bd0711,0x24d2,0x4ff7,{0x93,0x24,0xed,0x2e,0x5d,0x3a,0xba,0xfa}};

extern "C" const GUID __declspec(selectany) IID_ISampleGrabberCB =
    {0x0579154a,0x2b53,0x4994,{0xb0,0xd0,0xe7,0x73,0x14,0x8e,0xff,0x85}};
extern "C" const GUID __declspec(selectany) IID_ISampleGrabber =
    {0x6b652fff,0x11fe,0x4fce,{0x92,0xad,0x02,0x66,0xb5,0xd7,0xc7,0x8f}};
extern "C" const GUID __declspec(selectany) IID_IMediaDet =
    {0x65bd0710,0x24d2,0x4ff7,{0x93,0x24,0xed,0x2e,0x5d,0x3a,0xba,0xfa}};

struct __declspec(uuid("0579154a-2b53-4994-b0d0-e773148eff85"))
ISampleGrabberCB : IUnknown
{
    //
    // Raw methods provided by interface
    //

      virtual HRESULT __stdcall SampleCB (
        double SampleTime,
        struct IMediaSample * pSample ) = 0;
      virtual HRESULT __stdcall BufferCB (
        double SampleTime,
        unsigned char * pBuffer,
        long BufferLen ) = 0;
};

struct __declspec(uuid("6b652fff-11fe-4fce-92ad-0266b5d7c78f"))
ISampleGrabber : IUnknown
{
    //
    // Raw methods provided by interface
    //

      virtual HRESULT __stdcall SetOneShot (
        long OneShot ) = 0;
      virtual HRESULT __stdcall SetMediaType (
        struct _AMMediaType * pType ) = 0;
      virtual HRESULT __stdcall GetConnectedMediaType (
        struct _AMMediaType * pType ) = 0;
      virtual HRESULT __stdcall SetBufferSamples (
        long BufferThem ) = 0;
      virtual HRESULT __stdcall GetCurrentBuffer (
        /*[in,out]*/ long * pBufferSize,
        /*[out]*/ long * pBuffer ) = 0;
      virtual HRESULT __stdcall GetCurrentSample (
        /*[out,retval]*/ struct IMediaSample * * ppSample ) = 0;
      virtual HRESULT __stdcall SetCallback (
        struct ISampleGrabberCB * pCallback,
        long WhichMethodToCallback ) = 0;
};

struct __declspec(uuid("65bd0710-24d2-4ff7-9324-ed2e5d3abafa"))
IMediaDet : IUnknown
{
    //
    // Raw methods provided by interface
    //

      virtual HRESULT __stdcall get_Filter (
        /*[out,retval]*/ IUnknown * * pVal ) = 0;
      virtual HRESULT __stdcall put_Filter (
        /*[in]*/ IUnknown * pVal ) = 0;
      virtual HRESULT __stdcall get_OutputStreams (
        /*[out,retval]*/ long * pVal ) = 0;
      virtual HRESULT __stdcall get_CurrentStream (
        /*[out,retval]*/ long * pVal ) = 0;
      virtual HRESULT __stdcall put_CurrentStream (
        /*[in]*/ long pVal ) = 0;
      virtual HRESULT __stdcall get_StreamType (
        /*[out,retval]*/ GUID * pVal ) = 0;
      virtual HRESULT __stdcall get_StreamTypeB (
        /*[out,retval]*/ BSTR * pVal ) = 0;
      virtual HRESULT __stdcall get_StreamLength (
        /*[out,retval]*/ double * pVal ) = 0;
      virtual HRESULT __stdcall get_Filename (
        /*[out,retval]*/ BSTR * pVal ) = 0;
      virtual HRESULT __stdcall put_Filename (
        /*[in]*/ BSTR pVal ) = 0;
      virtual HRESULT __stdcall GetBitmapBits (
        double streamTime,
        long * pBufferSize,
        unsigned char * pBuffer,
        long Width,
        long Height ) = 0;
      virtual HRESULT __stdcall WriteBitmapBits (
        double streamTime,
        long Width,
        long Height,
        BSTR Filename ) = 0;
      virtual HRESULT __stdcall get_StreamMediaType (
        /*[out,retval]*/ struct _AMMediaType * pVal ) = 0;
      virtual HRESULT __stdcall GetSampleGrabber (
        /*[out]*/ struct ISampleGrabber * * ppVal ) = 0;
      virtual HRESULT __stdcall get_FrameRate (
        /*[out,retval]*/ double * pVal ) = 0;
      virtual HRESULT __stdcall EnterBitmapGrabMode (
        double SeekTime ) = 0;
};
