@echo off

if {%1}=={} (
	echo Usage: release ^<version-id^>
	exit /b 0
)

set _verid=%1

setlocal enabledelayedexpansion

if not exist publish md publish
if exist publish\build.log del publish\build.log
if exist publish\DShowInputDriver-!_verid!-src.zip del publish\DShowInputDriver-!_verid!-src.zip
if exist publish\DShowInputDriver-!_verid!.zip del publish\DShowInputDriver-!_verid!.zip

set _abverfile=src\DShowInputDriver\autobuild\version.h

if not exist src\DShowInputDriver\autobuild md src\DShowInputDriver\autobuild

echo Building x86...
devenv DShowInputDriver.sln /Rebuild Release^|Win32 /Out publish\build-x86.log >nul
if errorlevel 1 (
	echo Build failed!
	findstr /c:"error C" /c:"warning C" /c:"error L" /c:"warning L" publish\build-x86.log
	goto :cleanup
)

echo Building x64...
devenv DShowInputDriver.sln /Rebuild Release^|x64 /Out publish\build-x64.log >nul
if errorlevel 1 (
	echo Build failed!
	findstr /c:"error C" /c:"warning C" /c:"error L" /c:"warning L" publish\build-x64.log
	goto :cleanup
)

echo Creating source archive...
zip -q -9 -X -r publish\DShowInputDriver-!_verid!-src.zip ^
	source ^
	h ^
	Copying ^
	. ^
	-i *.vcproj *.sln *.cpp *.h *.fx *.rules *.asm *.xasm *.vsprops *.rc *.asm64 *.inl *.fxh *.vdfx *.inc *.k *.txt *.bmp *.def

zip -q -9 -X -r publish\DShowInputDriver-!_verid!-src.zip ^
	release.cmd

echo Creating release archive...
zip -q -9 -X publish\DShowInputDriver-!_verid!.zip ^
	release\DShowInputDriver.vdplugin ^
	x64\release\DShowInputDriver.vdplugin ^
	Copying

echo Copying PDBs...
copy release\DShowInputDriver.pdb publish\DShowInputDriver-!_verid!-x86.pdb | findstr /v /c:"1 file(s) copied"
copy release\DShowInputDriver.pdb publish\DShowInputDriver-!_verid!-x64.pdb | findstr /v /c:"1 file(s) copied"

dir publish
exit /b 0

:cleanup
exit /b 5
